<template>
  <el-select
    v-model="value"
    multiple
    filterable
    remote
    clearable
    :multiple-limit="1"
    reserve-keyword
    :size="size || 'medium'"
    style="width: 100%"
    :placeholder="placeholder || ''"
    :disabled="disabled"
    :remote-method="remoteMethod"
    :loading="selectLoading"
    @change="selectChange"
  >
    <el-option
      v-for="(item, index) in options"
      :key="item.companyNo + index"
      :label="item.companyName"
      :value="item.companyNo"
    />
    <!--      :disabled="item.status + '' !== '1'"-->
  </el-select>
</template>

<script>
import asyncRequest from '@/apis/components/search-customer'
import resToken from '@/mixins/resToken'
export default {
  name: 'SearchCustomer',
  mixins: [resToken],
  props: ['size', 'value', 'placeholder', 'isDetail', 'disabled', 'names'],
  /**
   * 属性集合
   * @param {String}        size             : 组件大小            非必填
   * @param {Array}         value            : 选中值              必填
   * @param {String}        placeholder      : 提示信息            非必填
   * @param {Boolean}       isDetail          : 是否是详情逻辑       必填
   * @param {Boolean}       disabled         : 是否禁用            必填
   * @param {String}        names            : 选中值label         展示详情必填
   */
  /**
   * 事件集合
   * @searchChange             : 选中值变化调用   抛出选中数据
   */
  data() {
    return {
      options: [],
      selectLoading: false,
      searchName: ''
    }
  },
  watch: {
    names: {
      handler: function(val, old) {
      // console.log(val, old);
        this.searchName = val
        if (this.isDetail && (Array.isArray(this.searchName) && this.searchName[0]) || (!Array.isArray(this.searchName) && this.searchName)) {
          this.remoteMethod(Array.isArray(this.searchName) ? this.searchName[0] : this.searchName)
        }
      },
      immediate: true
    }
  },
  mounted() {
    this.options = []
    this.selectLoading = false
  },
  methods: {
    async selectChange(e) {
      if (e && e.length > 0) {
        const index = this.options.findIndex((v) => v.companyNo === e[0])
        console.log(this.options[0])
        if (index !== -1) {
          const model = {
            area: this.options[index].area,
            id: this.options[index].id,
            code: this.options[index].companyNo,
            label: this.options[index].companyName
          }
          this.$emit('searchChange', model)
        } else {
          this.$emit('searchChange', {})
        }
      } else {
        this.$emit('searchChange', {})
      }
    },
    async remoteMethod(query) {
      this.selectLoading = true
      if (query !== '') {
        this.options = []
        const formValue = {
          page: 1,
          size: 100,
          companyName: query,
          companyNo: '',
          itemid: ''
        }

        const res = await asyncRequest.list(formValue)
        if (res && res.code === 0 && res.data) {
          const { item } = res.data
          this.options = item
        } else if (res && res.code >= 100 && res.code <= 104) {
          await this.logout()
        } else {
          this.$message.warning(res.message)
        }
      } else {
        this.options = []
      }
      this.selectLoading = false
    }
  }
}
</script>

<style>
</style>
